
import 'dart:async';

import 'package:flutter/services.dart';

class MoA5Plugin {
  static const MethodChannel _channel = MethodChannel('mo_a5_plugin');

  static Future<String?> startNfc() async {
    final String? version = await _channel.invokeMethod('startNfc');
    return version;
  }

  static Future<String?> closeNfc() async {
    final String? version = await _channel.invokeMethod('closeNfc');
    return version;
  }

  static Future<String?> startReading() async {
    final String? version = await _channel.invokeMethod('readCard');
    return version;
  }

  static Future<String?> haltOperation() async {
    final String? version = await _channel.invokeMethod('haltOperation');
    return version;
  }

  static Future<String?> authBlock({required blockNo, required authKey}) async {
    final String? version = await _channel.invokeMethod('authBlock', <String, dynamic>{
      'blockNo': blockNo,
      'password': authKey,
    });
    return version;
  }

  static Future<String?> readBlock({required blockNo}) async {
    final String? version = await _channel.invokeMethod('readBlock', <String, dynamic>{
      'blockNo': blockNo,
    });
    return version;
  }

  static Future<String?> writeBlock({required blockNo, required conent}) async {
    final String? version = await _channel.invokeMethod('writeBlock', <String, dynamic>{
      'blockNo': blockNo,
      'conent': conent,
    });
    return version;
  }

  static Future<String?> printContent({required content}) async {
    final String? result = await _channel.invokeMethod('printContent', <String, dynamic>{
      'content': content,
    });
    return result;
  }

  static Future<String?> printImage({required imageContent}) async {
    final String? result = await _channel.invokeMethod('printImage', <String, dynamic>{
      'imageContent': imageContent,
    });
    return result;
  }
}
